{{
DeepFry video Player v0.1
By : James Hughes (vampyre)

*Based on spudview by Jeff Ledger (OBC)
*Video Driver by Doug Dingus
*Wav file playback routines by Rayman
*Many thanks to Baggers for all the patience, help and inspiration.
 This player wouldn't exist without his input
*Thanks also to perry and everyone else whos hacked this a bit and helped
 find bugs
 
Requirements:
  NTSC tv which is hooked up to pins 12,13,14
  SD card

Note that this program will reboot on any error, so if you load this into the ROM it
might be irritating.

This player will play the file FROG.PVF
first, copy FROG.PVF to your SD card, then run this program

these files can be generated with the videomaker.exe which came with this package.
please read the README.TXT for information on converting your own videos

Known Bugs:
  The audio has pops and crackles during playback. I think its because it is not
double buffered yet.

all original code is Copyright (c) 2008  James Hughes under the MIT liscence
all other code is the property of its respective author and liscenced under the same liscence
  see the bottom of this file for further details

}}
CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000       '80 MHz

  spiDO     = 0
  spiClk    = 1
  spiDI     = 2
  spiCS     = 3

  HORIZONTAL_PIXELS = 80 
  VERTICAL_PIXELS   = 96 

Var
  byte displayb[HORIZONTAL_PIXELS * VERTICAL_PIXELS]   'allocate display buffer in RAM
  byte mywavdata[1024]
  long ioControl[2]     ' control address
  long stack1[100]
      
OBJ
    SD  : "FSRWfemto"
    tv   : "mashed_potatos"
    key  : "Combokeyboard"   
PUB Main|n,i,j,k

   key.start(26)     

   sd.start(@ioControl)
   sd.mount(spiDO,spiClk,spiDI,spiCS)

   repeat k from 0 to (HORIZONTAL_PIXELS * VERTICAL_PIXELS) 
     byte [@displayb] [k] := @@clut[1]  
   
   tv.start(@displayb) 

   'start the audio player in its own cog
   j := COGNEW(Player(10, 11),@stack1) 

  ' change FROG.PVF to the name of the video file you want to play
  i:=sd.popen(string("ozzy.pvf"), "r")
  if(i<0)
   reboot

  repeat

    'load sound chunk 
    i := sd.pread(@mywavdata, 1024)
    if(i<1024)
      reboot

     'load video frame
    i := sd.pread(@displayb,HORIZONTAL_PIXELS*VERTICAL_PIXELS)
    if(i<1)
      reboot
         
    'wait for buffer to finish playing
    repeat while(mywavdata[1023]<>0) 

pub plot(x,y,c)
  'very simple dot plotter
  'one byte per pixel is sweet!

  'c := c & %0111 'uncomment for monochrome display only

  'keep things sane
  x := x // HORIZONTAL_PIXELS
  y := y // VERTICAL_PIXELS
    
  displayb[y*HORIZONTAL_PIXELS+x] := @@clut[c & %01111111]   '128 color CLUT

PUB Player(PinR, PinL) | n,i,nextCnt,rate,dcnt
  'this is a bit slow, cause i dont know what im doing. enjoy :D

  'Set pins to output mode
  DIRA[PinR]~~                              'Set Right Pin to output
  DIRA[PinL]~~                              'Set Left Pin to output

  'Set up the counters
  CTRA:= %00110 << 26 + 0<<9 + PinR         'NCO/PWM Single-Ended APIN=Pin (BPIN=0 always 0)
  CTRB:= %00110 << 26 + 0<<9 + PinL         'NCO/PWM Single-Ended APIN=Pin (BPIN=0 always 0)   

 
  i:=0
  NextCnt:=cnt+15000

 repeat
      repeat i from 0 to 1023
         NextCnt+=5400 'should be 10000 for 8 ksps
         waitcnt(NextCnt)
         FRQA:=(byte[@mywavdata+i])<<24
         FRQB:=FRQA     
         rate := byte[@mywavdata+i]~




DAT

clut
clut0   byte  byte  $02, $03, $04, $05, $06, $07, $07, $07
clut1   byte  byte  $19, $1a, $1b, $1c, $1d, $1e, $98, $af
clut2   byte  byte  $29, $2a, $2b, $2c, $2d, $2e, $a8, $bf
clut3   byte  byte  $39, $3a, $3b, $3c, $3d, $3e, $b8, $cf
clut4   byte  byte  $49, $4a, $4b, $4c, $4d, $4e, $c8, $df
clut5   byte  byte  $59, $5a, $5b, $5c, $5d, $5e, $d8, $ef
clut6   byte  byte  $69, $6a, $6b, $6c, $6d, $6e, $e8, $ff
clut7   byte  byte  $79, $7a, $7b, $7c, $7d, $7e, $f8, $0f
clut8   byte  byte  $89, $8a, $8b, $8c, $8d, $8e, $08, $1f
clut9   byte  byte  $99, $9a, $9b, $9c, $9d, $9e, $18, $2f
cluta   byte  byte  $a9, $aa, $ab, $ac, $ad, $ae, $28, $3f
clutb   byte  byte  $b9, $ba, $bb, $bc, $bd, $be, $38, $4f
clutc   byte  byte  $c9, $ca, $cb, $cc, $cd, $ce, $48, $5f
clutd   byte  byte  $d9, $da, $db, $dc, $dd, $de, $58, $6f
clute   byte  byte  $e9, $ea, $eb, $ec, $ed, $ee, $68, $7f
clutf   byte  byte  $f9, $fa, $fb, $fc, $fd, $fe, $78, $8f
{{
                            TERMS OF USE: MIT License

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}
 